#include <iostream>
#include <vector>
#include <numeric>
using namespace std;

int N, K, bestsum;
vector<int> A, B, bestB;
vector<bool> banned;

int sum(const vector<int> &V) { return accumulate(V.begin(),V.end(),0); }

void skus(int zostava, int x) {
    if (x<0) {
        if (zostava==0 && sum(B)<bestsum) { bestsum=sum(B); bestB=B; }
    } else {
        int add = 0;
        if (!banned[x]) add = zostava/A[x];
        B[x] += add;
        skus(zostava - add*A[x], x-1);
    }
}

int main() {
    cin >> N;
    A.resize(N);
    for (int n=0; n<N; ++n) cin >> A[n];
    cin >> K;
    bestsum = K+1;
    bestB.resize(N,0);
    banned.resize(N,false);

    for (int n1=0; n1<N; ++n1) {
        for (int n2=0; n2<N; ++n2) {
            if (A[n1] + A[n2] <= K) {
                B.clear();
                B.resize(N,0);
                ++B[n1];
                ++B[n2];
                skus(K-A[n1]-A[n2],N-1);
            }
        }
    }

    for (int n1=0; n1<N; ++n1) {
    for (int n2=n1; n2<N; ++n2) {
    for (int n3=n2; n3<N; ++n3) {
    for (int n4=n3; n4<N; ++n4) {
        if (A[n1] + A[n2] + A[n3] + A[n4] <= K) {
            B.clear();
            B.resize(N,0);
            ++B[n1];
            ++B[n2];
            ++B[n3];
            ++B[n4];
            skus(K-A[n1]-A[n2]-A[n3]-A[n4],N-1);
        }
    }
    }
    }
    }

    for (int n1=0; n1<N; ++n1) {
    for (int n2=n1; n2<N; ++n2) {
    for (int n3=n2; n3<N; ++n3) {
    for (int n4=n3; n4<N; ++n4) {
            banned.clear();
            banned.resize(N,false);
            banned[n1] = true;
            banned[n2] = true;
            banned[n3] = true;
            banned[n4] = true;
            B.clear();
            B.resize(N,0);
            skus(K,N-1);
    }
    }
    }
    }

    cout << bestsum << endl;
    for (int n=0; n<N; ++n) cout << bestB[n] << (n==N-1 ? "\n" : " ");
}
